## Script (Python) "getSectionsTree"
##parameters=
# $Id: getSectionsTree.py,v 1.3 2003/05/28 08:29:03 ben Exp $
"""Get all sections info with allowed publishing transitions"""

sections = context.portal_trees.sections.getList()

wftool = context.portal_workflow
allowed_transitions = wftool.getAllowedPublishingTransitions(context)
type_name = context.portal_type

for section in sections:
    transitions =  wftool.getInitialTransitions(section['rpath'], type_name,
                                                wftool.TRANSITION_INITIAL_PUBLISHING)
    transitions = [t for t in transitions if t in allowed_transitions]
    section['publishing_transitions'] = transitions

return sections
